library dev;

uses
  SysUtils, Classes, windows, StrUtils,
  Unit2 in 'Unit2.pas';

var
 cp:COMLib;
 hh:THandle;
 f1:text;
 f2:file of integer;
 aa:integer;
 DTC:MDTCJ;

{$R *.res}

function MakeCO(s1:ShortString):ShortString;
var i:integer;
begin
 for i:=1 to Length(s1)-1 do
  if (s1[i]+s1[i+1])='\n' then
   begin s1[i]:=#$0D; s1[i+1]:=#$0A; end;
 MakeCO:=s1;
end;

function StrToFloatM(s:ShortString):double;
Const
 dig1:set of char=['0','1','2','3','4','5','6','7','8','9','.',',','-'];
var
 i,cd:integer;
 ss:ShortString;
begin
 ss:='';
 for i:=1 to length(s) do
  if (s[i] in dig1) then
   begin
    if (s[i]=',') then ss:=ss+'.' else ss:=ss+s[i];
   end;
 val(ss,Result,cd);
end;

procedure hex2buf(var buf:array of byte;var len:byte;s1:string);
const
    aa:array[0..15] of char=('0','1','2','3','4','5','6','7','8','9',
    'A','B','C','D','E','F');
 bb:set of char=['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'];
var
 i:integer;
 ss1:string;
begin
 ss1:='';
 for i:=1 to length(s1) do
  if (UpCase(s1[i]) in bb) then ss1:=ss1+UpCase(s1[i]);
 len:=0;
 while Length(ss1)>1 do
  begin
   buf[len]:=(pos(ss1[1],aa)-1)*16+pos(ss1[2],aa)-1;
   inc(len);
   if Length(ss1)>1 then ss1:=RightStr(ss1,Length(ss1)-2);
  end;
end;

function hextobyte(ss5:ShortString):byte;
const
    aa:array[0..15] of char=('0','1','2','3','4','5','6','7','8','9',
    'A','B','C','D','E','F');
 bb:set of char=['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'];
begin
 hextobyte:=0;
 if length(ss5)=1 then hextobyte:=pos(ss5[1],aa)-1;
 if length(ss5)>1 then hextobyte:=(pos(ss5[1],aa)-1)*16+pos(ss5[2],aa)-1;
end;

function hextoword(ss5:ShortString):word;
const
 aa:array[0..15] of char=('0','1','2','3','4','5','6','7','8','9',
    'A','B','C','D','E','F');
 bb:set of char=['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'];
begin
 hextoword:=0;
 if length(ss5)=1 then hextoword:=pos(ss5[1],aa)-1;
 if length(ss5)=2 then hextoword:=(pos(ss5[1],aa)-1)*16+pos(ss5[2],aa)-1;
 if length(ss5)>2 then hextoword:=(pos(ss5[1],aa)-1)*4096+(pos(ss5[2],aa)-1)*256+(pos(ss5[3],aa)-1)*16+pos(ss5[4],aa)-1;
end;

function DEVSTRT(C:PToDLL):boolean; stdcall;
var ss:ShortString;
    i,j,cnt,cnt2,k:integer;
begin
 DEVSTRT:=true; C^.DSYST.CMD:=$2000; //   
 if FileExists(C^.DSYST.PATHDLL+'dtc.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'dtc.ini'); reset(f1); DTC.LNG:=0;
   while not(eof(f1)) do
    begin
     readln(f1,ss);
     if Length(ss)>=4 then
      begin
       DTC.DTC[DTC.LNG].NUM:=HexToWord(copy(ss,1,4));
       if Length(ss)=6 then DTC.DTC[DTC.LNG].DOB:=HexToByte(copy(ss,5,2))
       else DTC.DTC[DTC.LNG].DOB:=0;
      end;
     readln(f1,ss); DTC.DTC[DTC.LNG].STR:=ss; inc(DTC.LNG);
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'ff.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'ff.ini'); reset(f1); C^.DFF.LNG:=0;
   while not eof(f1) do
    begin
     readln(f1,ss); C^.DFF.FF[C^.DFF.LNG].NAME:=ss;
     readln(f1,ss); C^.DFF.FF[C^.DFF.LNG].EDIZ:=ss;
     readln(f1,ss); C^.DFF.FF[C^.DFF.LNG].COMM:=MakeCO(ss);
     readln(f1,ss); C^.DFF.FF[C^.DFF.LNG].FORM:=ss;
     readln(f1,ss);
     hex2buf(C^.DFF.FF[C^.DFF.LNG].CMDD,C^.DFF.FF[C^.DFF.LNG].NCMD,ss);
     inc(C^.DFF.LNG);
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'par.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'par.ini'); reset(f1); C^.DPAR.LNG:=0;
   while not eof(f1) do
    begin
     readln(f1,ss); C^.DPAR.PAR[C^.DPAR.LNG].NAME:=ss;
     readln(f1,ss); C^.DPAR.PAR[C^.DPAR.LNG].EDIZ:=ss;
     readln(f1,ss); C^.DPAR.PAR[C^.DPAR.LNG].COMM:=MakeCO(ss);
     readln(f1,ss); C^.DPAR.PAR[C^.DPAR.LNG].FORM:=ss;
     readln(f1,ss);
     hex2buf(C^.DPAR.PAR[C^.DPAR.LNG].CMDD,C^.DPAR.PAR[C^.DPAR.LNG].NCMD,ss);
     inc(C^.DPAR.LNG);
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'act.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'act.ini'); reset(f1); C^.DACT.LNG:=0;
   while not eof(f1) do
    begin
     readln(f1,ss);
     C^.DACT.ACT[C^.DACT.LNG].NAME:=ss;
     readln(f1,ss); C^.DACT.ACT[C^.DACT.LNG].EDIZ:=ss;
     readln(f1,ss); C^.DACT.ACT[C^.DACT.LNG].COMM:=MakeCO(ss);
     readln(f1,ss); C^.DACT.ACT[C^.DACT.LNG].MINV:=StrToFloatM(ss);
     readln(f1,ss); C^.DACT.ACT[C^.DACT.LNG].MAXV:=StrToFloatM(ss);
     readln(f1,ss); C^.DACT.ACT[C^.DACT.LNG].DVAL:=StrToFloatM(ss);
     readln(f1,ss); C^.DACT.ACT[C^.DACT.LNG].FORM:=ss;
     readln(f1,ss);
     hex2buf(C^.DACT.ACT[C^.DACT.LNG].CMDD,C^.DACT.ACT[C^.DACT.LNG].NCMD,ss);
     inc(C^.DACT.LNG);
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'bit.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'bit.ini'); reset(f1);
   for i:=1 to 16 do
    begin
     readln(f1,ss); C^.DPAR.BIT[0][i-1]:=ss;
     readln(f1,ss); C^.DPAR.BIT[1][i-1]:=ss;
    end;
   for i:=1 to 16 do
    begin
     readln(f1,ss); C^.DFF.BIT[0][i-1]:=ss;
     readln(f1,ss); C^.DFF.BIT[1][i-1]:=ss;
    end;
   for i:=1 to 16 do
    begin
     readln(f1,ss); C^.DACT.BIT[0][i-1]:=ss;
     readln(f1,ss); C^.DACT.BIT[1][i-1]:=ss;
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'dig.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'dig.ini'); reset(f1);
   readln(f1,ss); cnt:=StrToInt(ss); k:=0;
   for j:=1 to cnt do
    begin
     readln(f1,ss); cnt2:=StrToInt(ss);
     C^.DPAR.DIGS[j-1]:=k; C^.DPAR.DIGL[j-1]:=cnt2;
     for i:=1 to cnt2 do
      begin readln(f1,ss); C^.DPAR.DIG[k]:=ss; inc(k); end;
    end;
   readln(f1,ss); cnt:=StrToInt(ss); k:=0;
   for j:=1 to cnt do
    begin
     readln(f1,ss); cnt2:=StrToInt(ss);
     C^.DFF.DIGS[j-1]:=k; C^.DFF.DIGL[j-1]:=cnt2;
     for i:=1 to cnt2 do
      begin readln(f1,ss); C^.DFF.DIG[k]:=ss; inc(k); end;
    end;
   readln(f1,ss); cnt:=StrToInt(ss); k:=0;
   for j:=1 to cnt do
    begin
     readln(f1,ss); cnt2:=StrToInt(ss);
     C^.DACT.DIGS[j-1]:=k; C^.DACT.DIGL[j-1]:=cnt2;
     for i:=1 to cnt2 do
      begin readln(f1,ss); C^.DACT.DIG[k]:=ss; inc(k); end;
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'fun.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'fun.ini'); reset(f1); C^.DFUN.LNG:=0;
   while not eof(f1) do
    begin
     readln(f1,ss); C^.DFUN.FUN[C^.DFUN.LNG].NAME:=ss;
     readln(f1,ss); C^.DFUN.FUN[C^.DFUN.LNG].COMM:=MakeCO(ss);
     readln(f1,ss); C^.DFUN.FUN[C^.DFUN.LNG].NEXE:=ss;
     inc(C^.DFUN.LNG);
    end;
   CloseFile(f1);
  end else exit;

 if FileExists(C^.DSYST.PATHDLL+'dev.ini') then
  begin
   AssignFile(f1,C^.DSYST.PATHDLL+'dev.ini'); reset(f1);
   while not(eof(f1)) do
    begin
     readln(f1,ss); C^.DSYST.Baud:=StrToInt(ss);
     readln(f1,ss); C^.DSYST.RTO:=StrToInt(ss);
     readln(f1,ss); C^.DSYST.RCNCT:=StrToInt(ss);
     readln(f1,ss); C^.DSYST.P4:=StrToInt(ss);
     readln(f1,ss); C^.DSYST.TiniL:=StrToInt(ss);
     readln(f1,ss); C^.DSYST.TiniH:=StrToInt(ss);
     readln(f1,ss); C^.DSYST.KWP:=HexToWord(ss);
     readln(f1,ss); C^.DSYST.MADR:=HexToWord(ss);
     readln(f1,ss); C^.DSYST.TAD:=HexToWord(ss);
     readln(f1,ss); C^.DSYST.REQAD:=HexToWord(ss);
    end;
   CloseFile(f1);
  end else exit;

 C^.DSYST.GST:=$00;
 cp:=COMLib.Create(true); hh:=cp.Handle;
 cp.C:=C;
 cp.PDTC:=@DTC;
 if FileExists(C^.DSYST.PATHDLL+'dev.set') then
  begin
   AssignFile(f2,C^.DSYST.PATHDLL+'dev.set'); reset(f2);
   read(f2,aa); C^.DSYST.dTiniL:=aa; read(f2,aa); C^.DSYST.dTiniH:=aa;
   read(f2,aa); C^.DSYST.dRTO:=aa; read(f2,aa); C^.DSYST.dP4:=aa;
   CloseFile(f2);
  end
 else
  begin
   C^.DSYST.dTiniH:=0; C^.DSYST.dTiniL:=0; C^.DSYST.dRTO:=0; C^.DSYST.dP4:=0;
  end;
 C^.DSYST.CMD:=$0000; cp.Resume;
 DEVSTRT:=false;
end;

exports DEVSTRT;

begin
 hh:=invalid_handle_value;
end.
